/**
 * Wahlsystem Prsidentschaftswahl USA 
 * 
 * Created on 31.05.2005
 * @author Melanie Gtz, Maximilian Stelzel & Patrick Dorsch
 *
 **/
package wasy;

import java.awt.Frame;
import java.awt.List;
import java.awt.Button;
import javax.swing.JOptionPane;

import java.awt.TextField;
import java.awt.Label;

public class Listenfenster extends Frame {

	private List list = null;
	private Button btnNeu = null;
	private Button btnAendern = null;
	private Button btnLoeschen = null;
	private Button btnBeenden = null;
	private Button btnErgebnis = null;
	
	private TextField txtDemo = null;
	private TextField txtRep = null;
	private TextField txtPraes = null;
	private Label label = null;
	private Label label1 = null;
	private Label label2 = null;
	private Label label3 = null;
	private Label label4 = null;
	private void showList() {       // schreibe den aktuellen Stand der Liste in die Listbox
		list.removeAll();
	  // Da telefonBuch als ArrayList definiert wurde, verwaltet es lediglich Instanzen von Object.
		// Um die Methoden getName() und getNummer() benutzen zu knnen muss wasy
		// in ein Array von Objekten dwer Klasse Eintrag konvertiert werden
		// Dieses Array heit dann wasyArray
		Eintrag telefonBuchArray[] = (Eintrag[])Main.wasy.toArray(new Eintrag[0]);
    for (int i = 0; i < telefonBuchArray.length; i++) {
		 list.add(telefonBuchArray[i].toString());
	  }
	}
	
	public Listenfenster() {        // Konstruktor des Listenfensters
		super();
		initialize();
	}
	
	private  void initialize() {    // initialisiert das Listenfenster
		label4 = new Label();
		label3 = new Label();
		label2 = new Label();
		label1 = new Label();
		label = new Label();
		this.setLayout(null);
		this.setTitle("Prsidentschaftswahlen in der USA");
		this.setBackground(java.awt.SystemColor.control);
		this.setBounds(100, 100, 529, 381);
		label.setBounds(198, 232, 160, 20);
		label.setText("Wahlmnner Demokraten:");
		label1.setBounds(198, 257, 160, 20);
		label1.setText("Wahlmnner Republikaner:");
		label2.setBounds(198, 282, 113, 20);
		label2.setText("Prsident:");
		label3.setBounds(295, 358, 221, 13);
		label3.setText("(c) by Melanie, Maximilian, Patrick 2005");
		label4.setBounds(29, 26, 467, 18);
		label4.setText("Staat                                                    Wahlmnner       Demokraten    Republikaner");
		this.add(getList(), null);
		this.add(getBtnNeu(), null);
		this.add(getBtnErgebnis(), null);
		this.add(getTxtDemo(), null);
		this.add(getTxtRep(), null);
		this.add(getTxtPraes(), null);
		this.add(label, null);
		this.add(label1, null);
		this.add(label2, null);
		this.add(getBtnAendern(), null);
		this.add(getBtnLoeschen(), null);
		this.add(getBtnBeenden(), null);
		this.add(label3, null);
		this.add(label4, null);
		this.addWindowListener(new java.awt.event.WindowAdapter() {   
			public void windowActivated(java.awt.event.WindowEvent e) {    
				showList();
			}   
			public void windowClosing(java.awt.event.WindowEvent e) {    
				System.exit(0);
			}
		});
	}
	
	private List getList() {        // Listbox 
		if (list == null) {
			list = new List();
			list.setBounds(20, 52, 487, 156);
			list.setName("lstTelefonBuch");
			list.setFont(new java.awt.Font("DialogInput", java.awt.Font.PLAIN, 14));
			showList();
		}
		return list;
	}

	private void neu() {            // Setzt selectedIndex = -1 und ffnet das Erfassungsfenster
		Main.selectedIndex = -1;                                        // Kennzeichen fr neuen Eintrag
		Main.erfassungsFenster.setVisible(true);                        // Erfassungsfenster einblenden
	}
	
	private Button getBtnNeu() {    // btnNeu
		if (btnNeu == null) {
			btnNeu = new Button();
			btnNeu.setBounds(93, 217, 90, 30);
			btnNeu.setName("btnNeu");
			btnNeu.setLabel("Neu");
			btnNeu.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnNeu.setVisible(true);
			btnNeu.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					neu();				}
			});
			btnNeu.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    		// Klickereignis			
					neu();				}
			});
		}
		return btnNeu;
	}

	
	private Button getBtnErgebnis() {    // BtnErgebnis
		if (btnErgebnis == null) {
			btnErgebnis = new Button();
			btnErgebnis.setName("btnErgebnis");
			btnErgebnis.setLabel("Ergebnis");
			btnErgebnis.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnErgebnis.setBounds(94, 321, 90, 30);
			btnErgebnis.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					ergebnis();				}
			});
			btnErgebnis.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    		// Klickereignis			
					ergebnis();				}
			});
		}
		return btnErgebnis;
	}
	
	private void ergebnis() { 
			Eintrag wasyArray[] = (Eintrag[])Main.wasy.toArray(new Eintrag[0]);
			int wmDemo=0, wmRep=0;
			for (int i=0; i<wasyArray.length; i++){
				if (wasyArray[i].getDemo()>wasyArray[i].getRep())wmDemo=wmDemo+ wasyArray[i].getWahlm();
				if (wasyArray[i].getDemo()<wasyArray[i].getRep())wmRep=wmRep+ wasyArray[i].getWahlm();
				}
			txtDemo.setText(wmDemo+"");
			txtRep.setText(wmRep+"");
			if (wmDemo>wmRep) txtPraes.setText("Demokrat");
			if (wmDemo<wmRep) txtPraes.setText("Republikaner");
			if (wmDemo==wmRep) txtPraes.setText("!Neuwahlen!");
			
	}
		
	
	
	private void aendern() {        // Aktualiert selectedIndex und ffnet das Erfassungsfenster 
		if (list.getSelectedIndex()<0) JOptionPane.showMessageDialog(null,"Sie mssen zuerst einen Datensatz auswhlen");
    // Teile dem Benutzer mit, dass er noch keinen Datensatz markiert hat
		else {
			Main.selectedIndex = list.getSelectedIndex();    // Setze die globale Variable fr den  ausgewhlten Index
			Main.erfassungsFenster.setVisible(true);         // Erfassungsfenster einblenden
		}
	}
	
	private Button getBtnAendern() { // btnAendern
		if (btnAendern == null) {
			btnAendern = new Button();
			btnAendern.setBounds(94, 252, 90, 30);
			btnAendern.setLabel("ndern");
			btnAendern.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnAendern.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					aendern();
				}
			});
			btnAendern.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					aendern();				}
			});
		}
		return btnAendern;
	}

	private void loeschen() {        // lscht den markierten Datensatz
		if(list.getSelectedIndex()<0) JOptionPane.showMessageDialog(null,"Sie mssen zuerst einen Datensatz auswhlen");
		else {
			Main.wasy.remove(list.getSelectedIndex());      // Lsche den markierten Eintrag in der Liste
			showList();                                            // zeige die genderte Liste neu an
		}
	}
	
	private Button getBtnLoeschen() { // btnLoeschen
		if (btnLoeschen == null) {
			btnLoeschen = new Button();
			btnLoeschen.setBounds(94, 287, 90, 30);
			btnLoeschen.setLabel("Lschen");
			btnLoeschen.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnLoeschen.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					loeschen();
				}
			});
			btnLoeschen.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					loeschen();				}
			});
		}
		return btnLoeschen;
	}
	
	private void beenden() {          // speichert wasy und beendet
		Main.saveWaSy();                                 // Speichere die genderte Liste in die Datei
		System.exit(0);                                         // Beendet die Anwendung
	}
	
	private Button getBtnBeenden() {  // btnBeenden
		if (btnBeenden == null) {
			btnBeenden = new Button();
			btnBeenden.setBounds(199, 322, 267, 30);
			btnBeenden.setLabel("Beenden");
			btnBeenden.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnBeenden.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					beenden();
				}
			});
			btnBeenden.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    					
					beenden();
				}
			});
		}
		return btnBeenden;
	}
	/**
	 * This method initializes textField	
	 * 	
	 * @return java.awt.TextField	
	 */    
	private TextField getTxtDemo() {
		if (txtDemo == null) {
			txtDemo = new TextField();
			txtDemo.setBounds(383, 232, 75, 20);
			txtDemo.setEnabled(false);
		}
		return txtDemo;
	}
	/**
	 * This method initializes textField1	
	 * 	
	 * @return java.awt.TextField	
	 */    
	private TextField getTxtRep() {
		if (txtRep == null) {
			txtRep = new TextField();
			txtRep.setBounds(383, 257, 75, 20);
			txtRep.setEnabled(false);
		}
		return txtRep;
	}
	/**
	 * This method initializes textField2	
	 * 	
	 * @return java.awt.TextField	
	 */    
	private TextField getTxtPraes() {
		if (txtPraes == null) {
			txtPraes = new TextField();
			txtPraes.setBounds(318, 282, 140, 20);
			txtPraes.setEnabled(false);
		}
		return txtPraes;
	}
   }  //  @jve:decl-index=0:visual-constraint="17,16"//  Klasse Listenfenster
