/**
 * Wahlsystem Prsidentschaftswahl USA 
 * 
 * Created on 31.05.2005
 * @author Melanie Gtz, Maximilian Stelzel & Patrick Dorsch
 *
 **/
package wasy;

import java.awt.Frame;

import java.awt.TextField;
import java.awt.Label;
import java.awt.Button;
import javax.swing.JLabel;

public class Erfassungsfenster extends Frame {   

	private TextField txtStaat = null;
	private TextField txtWahlm = null;
	private Label label = null;
	private Label label1 = null;
	private Button btnOK = null;
	private Button btnAbbrechen = null;
	
	private TextField txtDemo = null;
	private TextField txtRep = null;
	private JLabel labelDemo = null;
	private JLabel labelRep = null;
	private void uebernehmen() {         // schreibe die eingegebenen Daten in die dynamische Liste  
		if(Main.selectedIndex<0) {
		  // Da telefonBuch als ArrayList definiert wurde, verwaltet es lediglich Instanzen von Object.
			// Um die Methoden getName() und getNummer() benutzen zu knnen muss telefonBuch
			// in ein Array von Objekten dwer Klasse Eintrag konvertiert werden
			// Dieses Array heit dann telefonBuchArray
   		Eintrag wasyArray[] = (Eintrag[])Main.wasy.toArray(new Eintrag[0]);
   		int i=0;
   		while (i<wasyArray.length && wasyArray[i].getStaat().compareTo(txtStaat.getText())<0) {
   			i++;                        // erhhe i bis die Einfgestelle oder das Listenende erreicht ist
   		}
			Main.wasy.add(i,new Eintrag(txtStaat.getText(),Integer.parseInt( txtWahlm.getText()),Integer.parseInt( txtDemo.getText()), Integer.parseInt( txtRep.getText()) ));  // neuer Eintrag
			Main.selectedIndex = i;              
		}
		else {                                                     // Eintrag ndern
			Main.wasy.remove(Main.selectedIndex);             // Eintrag lschen
			Main.wasy.add(Main.selectedIndex,new Eintrag(txtStaat.getText(),Integer.parseInt( txtWahlm.getText()),Integer.parseInt( txtDemo.getText()), Integer.parseInt( txtRep.getText())    ));
			                                                         // Eintrag gendert einfgen
		}                                                                 
	}

	public Erfassungsfenster() {         // Konstruktor des Erfassungsfensters
		super();
		initialize();
	}
	
	private  void initialize() {         // Initialisierung des Erfassungsfensters
		labelDemo = new JLabel();
		labelRep = new JLabel();
		label1 = new Label();
		label = new Label();
		this.setLayout(null);
		this.setTitle("Wahlergebnisse");
		this.setBackground(java.awt.SystemColor.control);
		this.setBounds(100, 100, 446, 274);
		label.setBounds(20, 50, 114, 30);
		label.setText("Staat");
		label.setName("lblName");
		label.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
		label1.setBounds(20, 90, 115, 30);
		label1.setText("WahlMnner");
		label1.setName("lblNummer");
		label1.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
		labelDemo.setBounds(20, 128, 115, 31);
		labelDemo.setText("Demokraten");
		labelDemo.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
		labelRep.setBounds(19, 173, 116, 32);
		labelRep.setText("Republikaner");
		labelRep.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
		this.add(getTxtStaat(), null);
		this.add(getTxtWahlm(), null);
		this.add(label, null);
		this.add(label1, null);
		this.add(getBtnOK(), null);
		this.add(getBtnAbbrechen(), null);
		this.add(getTxtDemo(), null);
		this.add(getTxtRep(), null);
		this.add(labelDemo, null);
		this.add(labelRep, null);
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowActivated(java.awt.event.WindowEvent e) {    
				if (Main.selectedIndex < 0) {
					txtStaat.setText("");
					txtWahlm.setText("");
					txtDemo.setText("");
					txtRep.setText("");					
				}
				else {
				  // Da wasy als ArrayList definiert wurde, verwaltet es lediglich Instanzen von Object.
					// Um die Methoden getName() und getNummer() benutzen zu knnen muss telefonBuch
					// in ein Array von Objekten dwer Klasse Eintrag konvertiert werden
					// Dieses Array heit dann wasyArray
						Eintrag wasyArray[] = (Eintrag[])Main.wasy.toArray(new Eintrag[0]);
						txtStaat.setText(wasyArray[Main.selectedIndex].getStaat());
						txtWahlm.setText(String.valueOf(wasyArray[Main.selectedIndex].getWahlm()));
						txtDemo.setText(String.valueOf(wasyArray[Main.selectedIndex].getDemo()));
						txtRep.setText(String.valueOf(wasyArray[Main.selectedIndex].getRep()));
				}
			}
		});
	}

	private TextField getTxtStaat() {     // txtStaat
		if (txtStaat == null) {
			txtStaat = new TextField();
			txtStaat.setBounds(160, 50, 250, 30);
			txtStaat.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			txtStaat.setEnabled(true);
		}
		return txtStaat;
	}
	
	private TextField getTxtWahlm() {   // txtWahlm
		if (txtWahlm == null) {
			txtWahlm = new TextField();
			txtWahlm.setBounds(160, 90, 250, 30);
			txtWahlm.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			txtWahlm.setEnabled(true);
		}
		return txtWahlm;
	}


   
	private TextField getTxtDemo() {
		if (txtDemo == null) {
			txtDemo = new TextField();
			txtDemo.setBounds(160, 130, 250, 30);
			txtDemo.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
		}
		return txtDemo;
	}


	private TextField getTxtRep() {
		if (txtRep == null) {
			txtRep = new TextField();
			txtRep.setBounds(160, 175, 250, 30);
			txtRep.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
		}
		return txtRep;
	}
	
	
	
	
	private void OK () {                 // bernehnmen und Fenster schlieen
		uebernehmen();	
		Main.erfassungsFenster.setVisible(false);
	}

	private Button getBtnOK() {          // btnOK
		if (btnOK == null) {
			btnOK = new Button();
			btnOK.setBounds(28, 224, 164, 30);
			btnOK.setLabel("OK");
			btnOK.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnOK.setName("btnOK");
			btnOK.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					OK ();				}
			});
			btnOK.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					OK ();				}
			});
		}
		return btnOK;
	}
	
	private void abbrechen() {           // Erfassungsfe4nster schlieen  
		Main.erfassungsFenster.setVisible(false);
	}

	private Button getBtnAbbrechen() {   // btnAbbrechen
		if (btnAbbrechen == null) {
			btnAbbrechen = new Button();
			btnAbbrechen.setBounds(213, 224, 175, 30);
			btnAbbrechen.setLabel("Abbrechen");
			btnAbbrechen.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			btnAbbrechen.setName("btnAbbrechen");
			btnAbbrechen.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyPressed(java.awt.event.KeyEvent e) {    
					abbrechen();				}
			});
			btnAbbrechen.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					abbrechen();				}
			});
		}
		return btnAbbrechen;
	}

  }  //  @jve:decl-index=0:visual-constraint="8,35"//  Klasse Erfassungsfenster
