/**
 * Wahlsystem Prsidentschaftswahl USA 
 * 
 * Created on 31.05.2005
 * @author Melanie Gtz, Maximilian Stelzel & Patrick Dorsch
 *
 **/
package wasy;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;

public class Main {

	public static List wasy;                      // globale Variable, verwaltet die Eintrge als dynamische Liste
	public static Erfassungsfenster erfassungsFenster;   // globale Variable Erfassungsfenster
	public static int selectedIndex;                     // wird im Listenfenster gesetzt und im Erfassungsfenster gelesen
	private static String fileName;                      // wird in main gesetzt und in savewasy und laodwasy gelesen
	
	public static void saveWaSy() {               // speichert die Daten in die Datei filename
		try {
			FileOutputStream fos = new FileOutputStream(fileName); // Low-Level-Ausgabestream zur Datei fileName
			ObjectOutputStream o = new ObjectOutputStream (fos);   // High-Level-Ausgabestream 
			o.writeObject(wasy);                            // Schreibe die gesamte Liste in die Datei
			o.close();          
		} catch (Exception e) {
			  System.out.println(e);
		}
	}
	
  public static void loadWaSy() {               // ldt die Daten aus der Datei filename
		try {
			File f = new File (fileName);                           // ffne die Datei
			FileInputStream fis = new FileInputStream(f);           // Low-Level-Eingabestream aus Detie fileName
  		ObjectInputStream i = new ObjectInputStream(fis);       // High-Level-Eingabestream
  		wasy.clear();                                    // Lsche alle wasyeintrge
  		wasy = (List)i.readObject();                     // Lese die gesamze Liste als Objekt aus der Datei
  		                                                        // und konvertiere das Eingelesene in eine Liste
			fis.close();
		} 
		catch (Exception e) {
		  System.out.println(e);
	  }
	}
	
	public static void main(String[] args) {              
		fileName = "Wasy.txt";                      // Die Datei Wasy.txt im Projektverzeichnis
		wasy = new ArrayList();                     // Speicherplatz fr die globale Variable wasy
		loadWaSy();		                             // ldt die daten aus der Datei filename
		Listenfenster listenFenster = new Listenfenster(); // lege das Listenfenster an
		erfassungsFenster= new Erfassungsfenster();        // lege das Erfassungsfenster an
		listenFenster.show();                              // ffne das Listenfenster 
	}
}
